]> gitweb.factorcode.org Git - factor.git/blob - build.sh
build.sh: Recognize arm64 ipad/appletv.
[factor.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Programs returning != 0 will not cause script to exit
4 set +e
5
6 # Case insensitive string comparison
7 shopt -s nocaseglob
8 #shopt -s nocasematch
9
10 ECHO=echo
11 OS=
12 ARCH=
13 WORD=
14 GIT_PROTOCOL=${GIT_PROTOCOL:="git"}
15 GIT_URL=${GIT_URL:=$GIT_PROTOCOL"://github.com/factor/factor.git"}
16 SCRIPT_ARGS="$*"
17
18 REQUIRE_CLANG_VERSION=3.1
19
20 # return 1 on found
21 test_program_installed() {
22     if ! [[ -n $(type -p $1) ]] ; then
23         return 0;
24     fi
25     return 1;
26 }
27
28 # return 1 on found
29 test_programs_installed() {
30     local installed=0;
31     $ECHO -n "Checking for all($*)..."
32     for i in "$@" ;
33     do
34         test_program_installed $i
35         if [[ $? -eq 1 ]]; then
36             installed=$(( $installed + 1 ))
37         fi
38     done
39     if [[ $installed -eq $# ]] ; then
40         $ECHO "found!"
41         return 1
42     else
43         $ECHO "all not found."
44         return 0
45     fi
46 }
47
48 exit_script() {
49     if [[ $FIND_MAKE_TARGET = true ]] ; then
50         # Must be echo not $ECHO
51         echo $MAKE_TARGET;
52     fi
53     exit $1
54 }
55
56 ensure_program_installed() {
57     local installed=0;
58     $ECHO -n "Checking for any($*)..."
59     for i in "$@" ;
60     do
61         test_program_installed $i
62         if [[ $? -eq 1 ]]; then
63             $ECHO "found $i!"
64             installed=$(( $installed + 1 ))
65             return
66         fi
67     done
68     $ECHO "none found."
69     $ECHO -n "Install "
70     if [[ $# -eq 1 ]] ; then
71         $ECHO -n $1
72     else
73         $ECHO -n "any of [ $* ]"
74     fi
75     $ECHO " and try again."
76     if [[ $OS == macosx ]] ; then
77         $ECHO "If you have Xcode 4.3 or higher installed, you must install the"
78         $ECHO "Command Line Tools from Xcode Preferences > Downloads in order"
79         $ECHO "to build Factor."
80     fi
81     exit_script 1;
82 }
83
84 check_ret() {
85     RET=$?
86     if [[ $RET -ne 0 ]] ; then
87        $ECHO $1 failed
88        exit_script 2
89     fi
90 }
91
92 set_downloader() {
93     test_program_installed wget
94     if [[ $? -ne 0 ]] ; then
95         DOWNLOADER="wget -nd"
96         DOWNLOADER_NAME=wget
97         return
98     fi
99     test_program_installed curl
100     if [[ $? -ne 0 ]] ; then
101         DOWNLOADER="curl -L -f -O"
102         DOWNLOADER_NAME=curl
103         return
104     fi
105     $ECHO "error: wget or curl required"
106     exit_script 11
107 }
108
109 set_md5sum() {
110     test_program_installed md5sum
111     if [[ $? -ne 0 ]] ; then
112         MD5SUM=md5sum
113     else
114         MD5SUM="md5 -r"
115     fi
116 }
117
118 semver_into() {
119     RE_SEMVER="^([0-9]*)\.([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3.3-5
120     CLANG_RE_OLD="^([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3-5
121     if [[ $1 =~ $RE_SEMVER ]] ; then
122         export "$2=${BASH_REMATCH[1]}"
123         export "$3=${BASH_REMATCH[2]}"
124         export "$4=${BASH_REMATCH[3]}"
125         export "$5=${BASH_REMATCH[4]}"
126     elif [[ $1 =~ $CLANG_RE_OLD ]] ; then
127         export "$2=${BASH_REMATCH[1]}"
128         export "$3=${BASH_REMATCH[2]}"
129         export "$4=0"
130         export "$5=${BASH_REMATCH[3]}"
131     else
132         echo "unsupported version number, please report a bug: $1"
133         exit 123
134     fi
135 }
136
137 clang_version_ok() {
138     CLANG_VERSION=$(clang --version | head -n1)
139     CLANG_VERSION_RE='^[a-zA-Z0-9 ]* version (.*)$' # 3.3-5
140     if [[ $CLANG_VERSION =~ $CLANG_VERSION_RE ]] ; then
141         export "CLANG_VERSION=${BASH_REMATCH[1]}"
142         local CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
143         semver_into "$CLANG_VERSION" CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
144         if [[ $CLANG_MAJOR -lt 3
145             || ( $CLANG_MAJOR -eq 3 && $CLANG_MINOR -le 1 )
146             ]] ; then
147             echo "clang version required >= $REQUIRE_CLANG_VERSION, got $CLANG_VERSION"
148             return 1
149         fi
150     else
151         return 1
152     fi
153     return 0
154 }
155
156 set_cc() {
157     # on Cygwin we MUST use the MinGW "cross-compiler", therefore check these first
158     # furthermore, we prefer 64 bit over 32 bit versions if both are available
159
160     # we need this condition so we don't find a mingw32 compiler on linux
161     if [[ $OS == windows ]] ; then
162         test_programs_installed x86_64-w64-mingw32-gcc x86_64-w64-mingw32-g++
163         if [[ $? -ne 0 ]] ; then
164             [ -z "$CC" ] && CC=x86_64-w64-mingw32-gcc
165             [ -z "$CXX" ] && CXX=x86_64-w64-mingw32-g++
166             return
167         fi
168
169         test_programs_installed i686-w64-mingw32-gcc i686-w64-mingw32-g++
170         if [[ $? -ne 0 ]] ; then
171             [ -z "$CC" ] && CC=i686-w64-mingw32-gcc
172             [ -z "$CXX" ] && CXX=i686-w64-mingw32-g++
173             return
174         fi
175     fi
176
177     test_programs_installed clang clang++
178     if [[ $? -ne 0 ]] && clang_version_ok ; then
179         [ -z "$CC" ] && CC=clang
180         [ -z "$CXX" ] && CXX=clang++
181         return
182     fi
183
184     # gcc and g++ will fail to correctly build Factor on Cygwin
185     test_programs_installed gcc g++
186     if [[ $? -ne 0 ]] ; then
187         [ -z "$CC" ] && CC=gcc
188         [ -z "$CXX" ] && CXX=g++
189         return
190     fi
191
192     $ECHO "error: high enough version of either (clang/clang++) or (gcc/g++) required!"
193     exit_script 10
194 }
195
196 set_make() {
197     case $OS in
198         freebsd) MAKE=gmake ;;
199         *) MAKE=make ;;
200     esac
201     if [[ $MAKE = 'gmake' ]] ; then
202         ensure_program_installed gmake
203     fi
204 }
205
206 check_installed_programs() {
207     ensure_program_installed chmod
208     ensure_program_installed uname
209     ensure_program_installed git
210     ensure_program_installed wget curl
211     ensure_program_installed clang x86_64-w64-mingw32-gcc i686-w64-mingw32-gcc gcc
212     ensure_program_installed clang++ x86_64-w64-mingw32-g++ i686-w64-mingw32-g++ g++ cl
213     ensure_program_installed make gmake
214     ensure_program_installed md5sum md5
215     ensure_program_installed cut
216 }
217
218 check_library_exists() {
219     GCC_TEST=factor-library-test.c
220     GCC_OUT=factor-library-test.out
221     $ECHO -n "Checking for library $1..."
222     $ECHO "int main(){return 0;}" > $GCC_TEST
223     $CC $GCC_TEST -o $GCC_OUT -l $1 2>&-
224     if [[ $? -ne 0 ]] ; then
225         $ECHO "not found."
226     else
227         $ECHO "found."
228     fi
229     $DELETE -f $GCC_TEST
230     check_ret $DELETE
231     $DELETE -f $GCC_OUT
232     check_ret $DELETE
233 }
234
235 check_X11_libraries() {
236     check_library_exists GL
237     check_library_exists X11
238     check_library_exists pango-1.0
239 }
240
241 check_gtk_libraries() {
242     check_library_exists gobject-2.0
243     check_library_exists gtk-x11-2.0
244     check_library_exists gdk-x11-2.0
245     check_library_exists gdk_pixbuf-2.0
246     check_library_exists gtkglext-x11-1.0
247     check_library_exists atk-1.0
248     check_library_exists gio-2.0
249     check_library_exists gdkglext-x11-1.0
250     check_library_exists pango-1.0
251 }
252
253
254 check_libraries() {
255     case $OS in
256             linux) check_X11_libraries
257                    check_gtk_libraries;;
258             unix) check_gtk_libraries;;
259     esac
260 }
261
262 check_factor_exists() {
263     if [[ -d "factor" ]] ; then
264         $ECHO "A directory called 'factor' already exists."
265         $ECHO "Rename or delete it and try again."
266         exit_script 4
267     fi
268 }
269
270 find_os() {
271     if [[ -n $OS ]] ; then return; fi
272     $ECHO "Finding OS..."
273     local uname_s=$(uname -s)
274     check_ret uname
275     case $uname_s in
276         CYGWIN_NT-5.2-WOW64) OS=windows;;
277         *CYGWIN_NT*) OS=windows;;
278         *CYGWIN*) OS=windows;;
279         MINGW32*) OS=windows;;
280         MINGW64*) OS=windows;;
281         MSYS_NT*) OS=windows;;
282         *darwin*) OS=macosx;;
283         *Darwin*) OS=macosx;;
284         *linux*) OS=linux;;
285         *Linux*) OS=linux;;
286         FreeBSD) OS=freebsd;;
287         Haiku) OS=haiku;;
288     esac
289 }
290
291 find_architecture() {
292     if [[ -n $ARCH ]] ; then return; fi
293     $ECHO "Finding ARCH..."
294     uname_m=$(uname -m)
295     check_ret uname
296     case $uname_m in
297        i386) ARCH=x86;;
298        i686) ARCH=x86;;
299        i86pc) ARCH=x86;;
300        amd64) ARCH=x86;;
301        ppc64) ARCH=ppc;;
302        *86) ARCH=x86;;
303        *86_64) ARCH=x86;;
304        iPhone5*[3-9]) ARCH=arm64;;
305        iPhone[6-9]*) ARCH=arm64;;
306        iPhone[1-9][0-9]*) ARCH=arm64;;
307        iPad[4-9]*) ARCH=arm64;;
308        iPad[1-9][0-9]*) ARCH=arm64;;
309        AppleTV[5-9]*) ARCH=arm64;;
310        AppleTV[1-9][0-9]*) ARCH=arm64;;
311        "Power Macintosh") ARCH=ppc;;
312     esac
313 }
314
315 find_num_cores() {
316     $ECHO "Finding num cores..."
317     NUM_CORES=1
318     uname_s=$(uname -s)
319     check_ret uname
320     case $uname_s in
321         CYGWIN_NT-5.2-WOW64 | *CYGWIN_NT* | *CYGWIN* | MINGW32*) NUM_CORES=$NUMBER_OF_PROCESSORS;;
322         *linux* | *Linux*) NUM_CORES=$(getconf _NPROCESSORS_ONLN || nproc);;
323         *darwin* | *Darwin* | freebsd) NUM_CORES=$(sysctl -n hw.ncpu);;
324     esac
325 }
326
327 echo_test_program() {
328     #! Must be 'echo'
329     echo -e "int main(){ return (long)(8*sizeof(void*)); }"
330 }
331
332 c_find_word_size() {
333     $ECHO "Finding WORD..."
334     C_WORD="factor-word-size"
335     echo_test_program | $CC -o $C_WORD -xc -
336     check_ret $CC
337     ./$C_WORD
338     WORD_OUT=$?
339     case $WORD in
340         32) ;;
341         64) ;;
342         *)
343             echo "Word size should be 32/64, got $WORD"
344             exit_script 15;;
345     esac
346     $DELETE -f $C_WORD
347     echo "$WORD_OUT"
348 }
349
350 intel_macosx_word_size() {
351     ensure_program_installed sysctl
352     $ECHO -n "Testing if your Intel Mac supports 64bit binaries..."
353     sysctl machdep.cpu.extfeatures | grep EM64T >/dev/null
354     if [[ $? -eq 0 ]] ; then
355         WORD=64
356         $ECHO "yes!"
357     else
358         WORD=32
359         $ECHO "no."
360     fi
361 }
362
363 find_word_size() {
364     if [[ -n $WORD ]] ; then return; fi
365     if [[ $OS == macosx && $ARCH == x86 ]] ; then
366         intel_macosx_word_size
367     else
368         WORD=$(find_word_size_cpp || c_find_word_size)
369     fi
370 }
371
372 find_word_size_cpp() {
373     SIXTY_FOUR='defined(__aarch64__) || defined(__x86_64__) || defined(_M_AMD64) || defined(__PPC64__) || defined(__64BIT__)'
374     THIRTY_TWO='defined(i386) || defined(__i386) || defined(__i386__) || defined(_MIX86)'
375     cc -E -xc <(echo -e "#if ${SIXTY_FOUR}\n64\n#elif ${THIRTY_TWO}\n32\n#endif") | tail -1
376 }
377
378 set_factor_binary() {
379     case $OS in
380         windows) FACTOR_BINARY=factor.com;;
381         *) FACTOR_BINARY=factor;;
382     esac
383 }
384
385 set_factor_library() {
386     case $OS in
387         windows) FACTOR_LIBRARY=factor.dll;;
388         macosx) FACTOR_LIBRARY=libfactor.dylib;;
389         *) FACTOR_LIBRARY=libfactor.a;;
390     esac
391 }
392
393 set_factor_image() {
394     FACTOR_IMAGE=factor.image
395     FACTOR_IMAGE_FRESH=factor.image.fresh
396 }
397
398 echo_build_info() {
399     $ECHO OS=$OS
400     $ECHO ARCH=$ARCH
401     $ECHO NUM_CORES=$NUM_CORES
402     $ECHO WORD=$WORD
403     $ECHO DEBUG=$DEBUG
404     $ECHO REPRODUCIBLE=$REPRODUCIBLE
405     $ECHO CURRENT_BRANCH=$CURRENT_BRANCH
406     $ECHO FACTOR_BINARY=$FACTOR_BINARY
407     $ECHO FACTOR_LIBRARY=$FACTOR_LIBRARY
408     $ECHO FACTOR_IMAGE=$FACTOR_IMAGE
409     $ECHO MAKE_TARGET=$MAKE_TARGET
410     $ECHO BOOT_IMAGE=$BOOT_IMAGE
411     $ECHO MAKE_IMAGE_TARGET=$MAKE_IMAGE_TARGET
412     $ECHO GIT_PROTOCOL=$GIT_PROTOCOL
413     $ECHO GIT_URL=$GIT_URL
414     $ECHO DOWNLOADER=$DOWNLOADER
415     $ECHO CC=$CC
416     $ECHO CXX=$CXX
417     $ECHO MAKE=$MAKE
418     $ECHO COPY=$COPY
419     $ECHO DELETE=$DELETE
420 }
421
422 check_os_arch_word() {
423     if ! [[ -n $OS && -n $ARCH && -n $WORD ]] ; then
424         $ECHO "OS: $OS"
425         $ECHO "ARCH: $ARCH"
426         $ECHO "WORD: $WORD"
427         $ECHO "OS, ARCH, or WORD is empty.  Please report this."
428
429         $ECHO $MAKE_TARGET
430         exit_script 5
431     fi
432 }
433
434 set_build_info() {
435     check_os_arch_word
436     if [[ $OS == linux && $ARCH == ppc ]] ; then
437         MAKE_IMAGE_TARGET=linux-ppc.32
438         MAKE_TARGET=linux-ppc-32
439     elif [[ $OS == windows && $ARCH == x86 && $WORD == 64 ]] ; then
440         MAKE_IMAGE_TARGET=windows-x86.64
441         MAKE_TARGET=windows-x86-64
442     elif [[ $OS == windows && $ARCH == x86 && $WORD == 32 ]] ; then
443         MAKE_IMAGE_TARGET=windows-x86.32
444         MAKE_TARGET=windows-x86-32
445     elif [[ $ARCH == x86 && $WORD == 64 ]] ; then
446         MAKE_IMAGE_TARGET=unix-x86.64
447         MAKE_TARGET=$OS-x86-64
448     elif [[ $ARCH == x86 && $WORD == 32 ]] ; then
449         MAKE_IMAGE_TARGET=unix-x86.32
450         MAKE_TARGET=$OS-x86-32
451     else
452         MAKE_IMAGE_TARGET=$ARCH.$WORD
453         MAKE_TARGET=$OS-$ARCH-$WORD
454     fi
455     BOOT_IMAGE=boot.$MAKE_IMAGE_TARGET.image
456 }
457
458 parse_build_info() {
459     ensure_program_installed cut
460     $ECHO "Parsing make target from command line: $1"
461     OS=$(echo $1 | cut -d '-' -f 1)
462     ARCH=$(echo $1 | cut -d '-' -f 2)
463     WORD=$(echo $1 | cut -d '-' -f 3)
464
465     if [[ $OS == linux && $ARCH == ppc ]] ; then WORD=32; fi
466     if [[ $OS == linux && $ARCH == arm ]] ; then WORD=32; fi
467     if [[ $OS == macosx && $ARCH == ppc ]] ; then WORD=32; fi
468
469     $ECHO "OS=$OS"
470     $ECHO "ARCH=$ARCH"
471     $ECHO "WORD=$WORD"
472 }
473
474 find_build_info() {
475     find_os
476     find_architecture
477     find_num_cores
478     set_cc
479     find_word_size
480     set_current_branch
481     set_factor_binary
482     set_factor_library
483     set_factor_image
484     set_build_info
485     set_downloader
486     set_make
487     echo_build_info
488 }
489
490 invoke_git() {
491     git "$@"
492     check_ret git
493 }
494
495 git_clone() {
496     $ECHO "Downloading the git repository from github.com..."
497     invoke_git clone $GIT_URL
498 }
499
500 update_script_name() {
501     $ECHO "$(dirname $0)/_update.sh"
502 }
503
504 update_script() {
505     local -r update_script=$(update_script_name)
506     local -r bash_path=$(which bash)
507     $ECHO "updating from ${CURRENT_BRANCH}"
508     $ECHO "#!$bash_path" >"$update_script"
509     $ECHO "git pull \"$GIT_URL\" ${CURRENT_BRANCH}" >>"$update_script"
510     $ECHO "if [[ \$? -eq 0 ]]; then exec \"$0\" $SCRIPT_ARGS; else echo \"git pull failed\"; exit 2; fi" \
511         >>"$update_script"
512     $ECHO "exit 0" >>"$update_script"
513
514     chmod 755 "$update_script"
515     exec "$update_script"
516 }
517
518 update_script_changed() {
519     invoke_git diff --stat "$(invoke_git merge-base HEAD FETCH_HEAD)" FETCH_HEAD | grep 'build\.sh' >/dev/null
520 }
521
522 git_fetch() {
523     $ECHO "Fetching the git repository from github.com..."
524     set_current_branch
525
526     rm -f "$(update_script_name)"
527     $ECHO git fetch "$GIT_URL" "${CURRENT_BRANCH}"
528     invoke_git fetch "$GIT_URL" "${CURRENT_BRANCH}"
529
530     if update_script_changed; then
531         $ECHO "Updating and restarting the build.sh script..."
532         update_script
533     else
534         $ECHO "Updating the working tree..."
535         invoke_git pull "$GIT_URL" "${CURRENT_BRANCH}"
536     fi
537 }
538
539 cd_factor() {
540     cd "factor"
541     check_ret cd
542 }
543
544 set_copy() {
545     case $OS in
546         windows) COPY=cp;;
547         *) COPY=cp;;
548     esac
549 }
550
551 set_delete() {
552     case $OS in
553         windows) DELETE=rm;;
554         *) DELETE=rm;;
555     esac
556 }
557
558 backup_factor() {
559     $ECHO "Backing up factor..."
560     $COPY $FACTOR_BINARY $FACTOR_BINARY.bak
561     $COPY $FACTOR_LIBRARY $FACTOR_LIBRARY.bak
562     $COPY $BOOT_IMAGE $BOOT_IMAGE.bak
563     $COPY $FACTOR_IMAGE $FACTOR_IMAGE.bak
564     $ECHO "Done with backup."
565 }
566
567 check_makefile_exists() {
568     if [[ ! -e "GNUmakefile" ]] ; then
569         $ECHO ""
570         $ECHO "***GNUmakefile not found***"
571         $ECHO "You are likely in the wrong directory."
572         $ECHO "Run this script from your factor directory:"
573         $ECHO "     ./build.sh"
574         exit_script 6
575     fi
576 }
577
578 invoke_make() {
579     check_makefile_exists
580     $MAKE $MAKE_OPTS "$@"
581     check_ret $MAKE
582 }
583
584 make_clean() {
585     invoke_make clean
586 }
587
588 make_factor() {
589     $ECHO "Building factor with $NUM_CORES cores"
590     invoke_make CC=$CC CXX=$CXX $MAKE_TARGET -j$NUM_CORES
591 }
592
593 make_clean_factor() {
594     make_clean
595     make_factor
596 }
597
598 current_git_branch() {
599     # git rev-parse --abbrev-ref HEAD # outputs HEAD for detached head
600     # outputs nothing for detached HEAD, which is fine for ``git fetch``
601     git describe --all --exact-match 2>/dev/null | sed 's=.*/=='
602 }
603
604 check_url() {
605     if [[ $DOWNLOADER_NAME == 'wget' ]]; then
606         if [[ $(wget -S --spider $1 2>&1 | grep 'HTTP/1.1 200 OK') ]]; then
607             return 0
608         else
609             return 1
610         fi
611     elif [[ $DOWNLOADER_NAME == 'curl' ]]; then
612         local code=$(curl -sL -w "%{http_code}\\n" "$1" -o /dev/null)
613         if [[ $code -eq 200 ]]; then return 0; else return 1; fi
614     else
615         $ECHO "error: wget or curl required in check_url"
616         exit_script 12
617     fi
618 }
619
620 # If we are on a branch, first try to get a boot image for that branch.
621 # Otherwise, just use `master`
622 set_boot_image_vars() {
623     set_current_branch
624     local url="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/checksums.txt"
625     check_url $url
626     if [[ $? -eq 0 ]]; then
627         CHECKSUM_URL="$url"
628         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/${BOOT_IMAGE}"
629     else
630         CHECKSUM_URL="http://downloads.factorcode.org/images/master/checksums.txt"
631         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/master/${BOOT_IMAGE}"
632     fi
633 }
634
635 set_current_branch() {
636     if [ -n "${CI_BRANCH}" ]; then
637         CURRENT_BRANCH="${CI_BRANCH}"
638     else
639         CURRENT_BRANCH=$(current_git_branch)
640     fi
641 }
642
643 update_boot_image() {
644     set_boot_image_vars
645     $ECHO "Deleting old images..."
646     $DELETE checksums.txt* > /dev/null 2>&1
647     # delete boot images with one or two characters after the dot
648     $DELETE $BOOT_IMAGE.{?,??} > /dev/null 2>&1
649     $DELETE temp/staging.*.image > /dev/null 2>&1
650     if [[ -f $BOOT_IMAGE ]] ; then
651         get_url $CHECKSUM_URL
652         local factorcode_md5=$(cat checksums.txt | grep $BOOT_IMAGE | cut -f2 -d' ')
653         set_md5sum
654         local disk_md5=$($MD5SUM $BOOT_IMAGE | cut -f1 -d' ')
655         $ECHO "Factorcode md5: $factorcode_md5";
656         $ECHO "Disk md5: $disk_md5";
657         if [[ "$factorcode_md5" == "$disk_md5" ]] ; then
658             $ECHO "Your disk boot image matches the one on downloads.factorcode.org."
659         else
660             $DELETE $BOOT_IMAGE > /dev/null 2>&1
661             get_boot_image
662         fi
663     else
664         get_boot_image
665     fi
666 }
667
668 get_boot_image() {
669     $ECHO "Downloading boot image $BOOT_IMAGE."
670     get_url "${BOOT_IMAGE_URL}"
671 }
672
673 get_url() {
674     if [[ -z $DOWNLOADER ]] ; then
675         set_downloader;
676     fi
677     $ECHO $DOWNLOADER $1 ;
678     $DOWNLOADER $1
679     check_ret $DOWNLOADER
680 }
681
682 get_config_info() {
683     find_build_info
684     check_installed_programs
685     check_libraries
686 }
687
688 copy_fresh_image() {
689     $ECHO "Copying $FACTOR_IMAGE to $FACTOR_IMAGE_FRESH..."
690     $COPY $FACTOR_IMAGE $FACTOR_IMAGE_FRESH
691 }
692
693 bootstrap() {
694     ./$FACTOR_BINARY -i=$BOOT_IMAGE
695     copy_fresh_image
696 }
697
698 install() {
699     check_factor_exists
700     get_config_info
701     git_clone
702     cd_factor
703     make_factor
704     set_boot_image_vars
705     get_boot_image
706     bootstrap
707 }
708
709 update() {
710     get_config_info
711     git_fetch
712     backup_factor
713     make_clean_factor
714 }
715
716 download_and_bootstrap() {
717     update_boot_image
718     bootstrap
719 }
720
721 net_bootstrap_no_pull() {
722     get_config_info
723     make_clean_factor
724     download_and_bootstrap
725 }
726
727 refresh_image() {
728     ./$FACTOR_BINARY -e="USING: vocabs.loader vocabs.refresh system memory ; refresh-all save 0 exit"
729     check_ret factor
730 }
731
732 make_boot_image() {
733     ./$FACTOR_BINARY -run="bootstrap.image" "$MAKE_IMAGE_TARGET"
734     check_ret factor
735 }
736
737 install_deps_apt() {
738     sudo apt install --yes libc6-dev libpango1.0-dev libx11-dev xorg-dev libgtk2.0-dev gtk2-engines-pixbuf libgtkglext1-dev wget git git-doc rlwrap clang make screen tmux libssl-dev
739     check_ret sudo
740 }
741
742 install_deps_pacman() {
743     sudo pacman --noconfirm -Syu gcc clang make rlwrap git wget pango glibc gtk2 gtk3 gtkglext gtk-engines gdk-pixbuf2 libx11 screen tmux
744     check_ret sudo
745 }
746
747 install_deps_dnf() {
748     sudo dnf --assumeyes install gcc gcc-c++ glibc-devel binutils libX11-devel pango-devel gtk3-devel gdk-pixbuf2-devel gtkglext-devel tmux rlwrap wget
749     check_ret sudo
750 }
751
752 install_deps_pkg() {
753     sudo pkg install --yes git gmake gcc rlwrap ripgrep curl gmake x11-toolkits/gtk30 x11-toolkits/gtkglext pango cairo vim
754 }
755
756
757 install_deps_macosx() {
758     test_program_installed git
759     if [[ $? -ne 1 ]] ; then
760         ensure_program_installed yes
761         $ECHO "git not found."
762         $ECHO "This script requires either git-core or port."
763         $ECHO "If it fails, install git-core or port and try again."
764         ensure_program_installed port
765         $ECHO "Installing git-core with port...this will take awhile."
766         yes | sudo port install git-core
767     fi
768 }
769
770 usage() {
771     $ECHO "usage: $0 command [optional-target]"
772     $ECHO "  install - git clone, compile, bootstrap"
773     $ECHO "  deps-apt - install required packages for Factor on Linux using apt"
774     $ECHO "  deps-pacman - install required packages for Factor on Linux using pacman"
775     $ECHO "  deps-dnf - install required packages for Factor on Linux using dnf"
776     $ECHO "  deps-pkg - install required packages for Factor on FreeBSD using pkg"
777     $ECHO "  deps-macosx - install git on MacOSX using port"
778     $ECHO "  self-update - git pull, recompile, make local boot image, bootstrap"
779     $ECHO "  quick-update - git pull, refresh-all, save"
780     $ECHO "  update|latest - git pull, recompile, download a boot image, bootstrap"
781     $ECHO "  compile - compile the binary"
782     $ECHO "  recompile - recompile the binary"
783     $ECHO "  bootstrap - bootstrap with existing boot image"
784     $ECHO "  net-bootstrap - recompile, download a boot image, bootstrap"
785     $ECHO "  make-target - find and print the os-arch-cpu string"
786     $ECHO "  report|info - print the build variables"
787     $ECHO "  update-boot-image - get the boot image for the current branch of for master"
788     $ECHO ""
789     $ECHO "If you are behind a firewall, invoke as:"
790     $ECHO "env GIT_PROTOCOL=http $0 <command>"
791     $ECHO ""
792     $ECHO "Example for overriding the default target:"
793     $ECHO "    $0 update macosx-x86-32"
794 }
795
796 MAKE_TARGET=unknown
797
798 # -n is nonzero length, -z is zero length
799 if [[ -n "$2" ]] ; then
800     parse_build_info $2
801 fi
802
803 if [ "$#" -gt 3 ]; then
804     usage
805     $ECHO "error: too many arguments"
806     exit 1
807 fi
808
809
810 set_copy
811 set_delete
812
813 case "$1" in
814     install) install ;;
815     deps-apt) install_deps_apt ;;
816     deps-pacman) install_deps_pacman ;;
817     deps-macosx) install_deps_macosx ;;
818     deps-dnf) install_deps_dnf ;;
819     deps-pkg) install_deps_pkg ;;
820     self-bootstrap) get_config_info; make_boot_image; bootstrap;;
821     self-update) update; make_boot_image; bootstrap;;
822     quick-update) update; refresh_image ;;
823     update|latest) update; download_and_bootstrap ;;
824     compile) find_build_info; make_factor ;;
825     recompile) find_build_info; make_clean; make_factor ;;
826     bootstrap) get_config_info; bootstrap ;;
827     net-bootstrap) net_bootstrap_no_pull ;;
828     make-target) FIND_MAKE_TARGET=true; ECHO=false; find_build_info; exit_script ;;
829     report|info) find_build_info ;;
830     full-report) find_build_info; check_installed_programs; check_libraries ;;
831     update-boot-image) find_build_info; check_installed_programs; update_boot_image;;
832     *) usage ;;
833 esac
834